


//run multiple tests

public class irisExperiment extends CANTExperiment {
	
  public int numInputTypes = 75;
  public int numTests = 75;
  
  private int trainTestNet[][];//offset,trainInstances
  private int trainTestInput;
  private int testNet[];
  private int firstTestAnswerCycle=0;

  public irisExperiment () {
    trainingLength = 20000; 
    inTest = false;
    presentTrainUntil = trainingLength + (75 * numInputTypes) ;
    answers = new int[numTests];
    realAnswers = new int[numInputTypes];
	irisNet somNet = (irisNet) getNet("SomNet");
    int somNetSize = somNet.getSize();
    trainTestNet = new int[somNetSize][numInputTypes];
    trainTestInput = 0;
    testNet = new int[somNetSize];
  }
  
  public boolean experimentDone(int CANTStep) {
	if (CANTStep > trainingLength + (75 * numInputTypes) + 
			(75 * numTests)+ 75 )
		return true;
    return false;  
  }
  
  public void switchToTest () {
    System.out.println("swithctotest ");
    inTest = true;
	irisNet somNet = (irisNet) getNet("SomNet");
	irisNet inputNet = (irisNet) getNet("BaseNet");
	somNet.setLearningOn(false);
	inputNet.setLearningOn(false);
  }
  
  private void  printNumFiring(int currentStep) {
		irisNet somNet = (irisNet) getNet("SomNet");
		int numFiring = 0;
		
		for (int i = 0; i < somNet.getSize(); i ++)
			if (somNet.neurons[i].getFired()) numFiring++;
		
		//System.out.println(currentStep + " " + numFiring);  
  }
  
  public boolean isEndEpoch(int currentStep) {
	irisNet inputNet = (irisNet) getNet("BaseNet");
	irisNet somNet = (irisNet) getNet("SomNet");
	
	/*if ((currentStep %5000) == 0)
	  {
		//inputNet.printSomLocales();
		inputNet.setLearningRate(inputNet.getLearningRate()*0.7f);
		somNet.setLearningRate(inputNet.getLearningRate()*0.7f);
	   }*/
	printNumFiring(currentStep);
	
    if ((currentStep% inputNet.getCyclesPerRun()) == 0 ) 
    	{
    	irisCANT.resetForNewTest();
    	return (true);
    	}
    return (false);
    
}
  //put the train som net into a fired array.  We'll use this to 
  //compare later.
	private void saveTrainNet() {
		irisNet somNet = (irisNet) getNet("SomNet");
		//int measureStep = irisCANT.CANTStep - 55;
		for (int measureStep = irisCANT.CANTStep -75; 
				measureStep < irisCANT.CANTStep; measureStep++)
		for (int offset = 0; offset < somNet.getSize(); offset++) {
				trainTestNet[offset][trainTestInput] += somNet.measure
						.getActiveState(measureStep, offset);
		}
		trainTestInput++;
	}
	
	private void saveTheTestNet() {
		irisNet somNet = (irisNet) getNet("SomNet");

		for (int offset = 0; offset < somNet.getSize(); offset++) {
			testNet[offset] = 0;
		}

		//int measureStep = irisCANT.CANTStep - 30;
		for (int measureStep = irisCANT.CANTStep -75; 
				measureStep < irisCANT.CANTStep; measureStep++)
		for (int offset = 0; offset < somNet.getSize(); offset++) {
			testNet[offset] += somNet.measure.getActiveState(measureStep, offset);
		}
		trainTestInput++;
	}

	public void debugPrintTrainTestNets(){
	    for ( int counter = 0; counter < 1000; counter++ )
	       if ((trainTestNet[counter][0] == 0) &&
	           (trainTestNet[counter][1] == 0))
	    	   
		    System.out.println("dTTT " +  counter);
	}
	
	  public double getTestTrainCorrelation(int testItem){
		    double Correlation;
		    double Sxx =0;
		    double Syy =0;
		    double Sxy =0;
		    double MeanS;
		    double MeanY;
		    double Sx=0;
		    double Sy=0;
			 
			irisNet somNet = (irisNet) getNet("SomNet");
		    int size = somNet.getSize();
	   
		    for ( int counter = 0; counter <size; counter++ )
		      Sx += testNet[counter];
		    MeanS = Sx/size;

		    for ( int counter = 0; counter < size; counter++ )
		      { Sy += trainTestNet[counter][testItem]; }
		    MeanY = Sy/size;

		    for ( int counter = 0; counter <size; counter++ ) {
		      Sxx += (testNet[counter]- MeanS)*(testNet[counter]- MeanS);
		      Syy += (trainTestNet[counter][testItem]- MeanY)*(trainTestNet[counter][testItem]- MeanY);
		      Sxy += (testNet[counter]- MeanS)*(trainTestNet[counter][testItem]- MeanY); }

		    Correlation = Sxy/(Math.sqrt (Sxx*Syy));
			return Correlation;
		  }
  
    int presentTrainUntil; //set in constructor
    int answers[];  //answers from the test data; the system doesn't know this.
    int answerCount=0;
    int realAnswers[];  //Answers from the training data.
    int realAnswerCount=0;
    boolean testFileOpened = false;

	public void endEpoch() {
		// read a pattern from the file.
		irisNet inputNet = (irisNet) getNet("BaseNet");
		if (inTest && (irisCANT.CANTStep <= presentTrainUntil)) {
			if (firstTestAnswerCycle == 0) {
				firstTestAnswerCycle = irisCANT.CANTStep;
				// System.out.println("FTA " + firstTestAnswerCycle);
			} else {
				saveTrainNet();
				realAnswers[realAnswerCount++] = correctAnswer;
			}
		}
		if (inTest && (irisCANT.CANTStep > presentTrainUntil)
				&& (!testFileOpened)) {
			testFileOpened = true;
			realAnswers[realAnswerCount++] = correctAnswer;
			irisCANT.setTestReader();
			irisCANT.patReader.setIrisPattern(inputNet, this, true);
			inputNet.setNeuronsToStimulate(40);
			saveTrainNet();
		} else if (inTest && (irisCANT.CANTStep > presentTrainUntil)) {
			irisCANT.patReader.setIrisPattern(inputNet, this, true);
			inputNet.setNeuronsToStimulate(40);
			answers[answerCount++] = correctAnswer;
		} else {
			irisCANT.patReader.setIrisPattern(inputNet, this, false);
            inputNet.setNeuronsToStimulate(60);
		}
	}
  
 
  public double printConnectionWeights(int step, String netName) {
	double totWeight = 0;
	int posNeurons = 0;
	irisNet net = (irisNet) getNet(netName);
    
	for (int i = 0; i < net.getSize(); i++) {
	  if (!net.neurons[i].isInhibitory()) {
		posNeurons++;
	    for (int synapse=0;synapse < net.neurons[i].getCurrentSynapses(); synapse++) {
		  totWeight += net.neurons[i].synapses[synapse].getWeight(); 
	    }    	   
	  }
	}
	return totWeight/posNeurons;
	//System.out.println("Weights " + step + " " + totWeight/totSynapses);
  } 
    	
  public void printExpName () {
    System.out.println("yeast Exp");
  }
  
   
  private int correctCategorisations = 0;
  private int bestTestNum = -1;
  private void printADecision (int currentStep) {  
	   saveTheTestNet();
	   double bestResult = 0;
	   int answer = -1;
	   for (int testNum = 0; testNum < numInputTypes; testNum ++)
	   {
  	     double result = getTestTrainCorrelation(testNum);
//System.out.println("Compare Answer " + correctAnswer + " " + result + " " + realAnswers[testNum]);	  
  	     if (result > bestResult) {
  	    	 answer = realAnswers[testNum];
  	    	 bestTestNum = testNum;
  	    	 bestResult = result;
  	     }
  	     
	   }
	   if (correctAnswer == answer) correctCategorisations++;
	   //System.out.println("Real Answer " + bestTestNum + " " + correctAnswer + " " + answer);	  
  }

	public void measure(int currentStep) {
		if (currentStep <= trainingLength + (75 * numInputTypes))
			return;

		if (((currentStep - trainingLength) % 75) == 0) {
			printADecision(currentStep);
		}
		if (currentStep == trainingLength + (75 * numInputTypes)
				+ +(75 * numTests))
			System.out.println(" Decisions " + correctCategorisations);
	}
  
} //end class


