

import java.util.Enumeration;

	public class iris2Net extends CANTNet {  	 
	  public iris2Net(){
	  }
	  
	  public iris2Net(String name,int cols, int rows,int topology){
	    super(name,cols,rows,topology);
		cyclesToStimulatePerRun = 40;
		recordingActivation = true;
	  }

	//This really slows down processing.  
	public void updateIncomingStrengthsSlow(){
	   for (int cNeuron = 0; cNeuron < getTotalNeurons(); cNeuron++) {
	     CANTNeuronSpontaneousFatigue modNeuron = (CANTNeuronSpontaneousFatigue)
	       neurons[cNeuron];
	     modNeuron.setIncomingStrength(modNeuron.getIncomingStrength(3));
	   }
	}

	public void zeroIncomingStrengths(){
	  for (int cNeuron = 0; cNeuron < getTotalNeurons(); cNeuron++) {
	     CANTNeuronSpontaneousFatigue modNeuron = (CANTNeuronSpontaneousFatigue)
	       neurons[cNeuron];
	     modNeuron.setIncomingStrength(0);
	  }
	}

	// need this to subclass experiment
	public void changePattern(int cantStep) {
		// note this only runs on the first step. The rest of the time it
		// is in experiment.endEpoch.
		if (cantStep == 0) {
			if (getName().compareTo("OutputNet") == 0) {
				int curPattern = getCurrentPattern();
				setCurrentPattern(curPattern);
				((CANTPattern) patterns.get(curPattern))
						.arrange(getNeuronsToStimulate());
			} 
			else  {
				int curPattern = 0;
				setCurrentPattern(curPattern);
				//((CANTPattern) patterns.get(curPattern)).arrange(getNeuronsToStimulate());
			}
		}
	}
	  
	  public void readBetweenAllNets() {
	    int netsChecked = 0;
	    Enumeration <?> eNum = CANT23.nets.elements();
	    iris2Net net = (iris2Net) eNum.nextElement();
	    iris2Net baseNet = net;
	    iris2Net somNet = net;

	    System.out.println("som1 read Between");

	      iris2Net gasNet = net;
	      do {
	        System.out.println(net.getName());
	        if (net.getName().compareTo("BaseNet") == 0)
	          baseNet = net;
	        else if (net.getName().compareTo("SomNet") == 0)
	          somNet = net;
	        else
	          System.out.println(net.getName() + " missed net in connect all");
	        netsChecked++;
	        if (netsChecked < 2)
	          net = (iris2Net) eNum.nextElement();
	      } while (netsChecked < 2);

	      baseNet.readConnectTo(somNet);
	  }
	  
	  
	  
	  public void runAllOneStep(int CANTStep) {
		//printSOMOn();
		  
	    //This series of loops is really chaotic, but I needed to
	    //get all of the propagation done in each net in step.
	    iris2CANT.runOneStepStart();
		
	    Enumeration <?> eNum = CANT23.nets.elements();
	    while (eNum.hasMoreElements()) {
	      iris2Net net = (iris2Net)eNum.nextElement();
	      //net.runOneStep(CANTStep);
	      net.changePattern(CANTStep);
	    }
	    eNum = CANT23.nets.elements();
	    while (eNum.hasMoreElements()) {
	      iris2Net net = (iris2Net)eNum.nextElement();
	      net.setExternalActivation(CANTStep);
	    }
	    
	    iris2CANT.globInhibition.applyGlobalInhibition();
	    //net.propogateChange();  
	    eNum = CANT23.nets.elements();
	    while (eNum.hasMoreElements()) {
	      iris2Net net = (iris2Net)eNum.nextElement();
	      net.setNeuronsFired();
	    }
	    eNum = CANT23.nets.elements();
	    while (eNum.hasMoreElements()) {
	      iris2Net net = (iris2Net)eNum.nextElement();
	      net.setDecay ();
	    }
	    eNum = CANT23.nets.elements();
	    while (eNum.hasMoreElements()) {
	      iris2Net net = (iris2Net)eNum.nextElement();
	      net.spreadActivation();
	    }
	    eNum = CANT23.nets.elements();
	    while (eNum.hasMoreElements()) {
	      iris2Net net = (iris2Net)eNum.nextElement();
	      net.setFatigue();
	    }
	    eNum = CANT23.nets.elements();
	    while (eNum.hasMoreElements()) {
	      iris2Net net = (iris2Net)eNum.nextElement();
	      net.learn();
	    }
	    eNum = CANT23.nets.elements();
	    while (eNum.hasMoreElements()) {
	      iris2Net net = (iris2Net)eNum.nextElement();
	      net.cantFrame.runOneStep(CANTStep+1);
	    }
	    eNum = CANT23.nets.elements();
	    while (eNum.hasMoreElements()) {
	      iris2Net net = (iris2Net)eNum.nextElement();
	      if (net.recordingActivation) net.setMeasure(CANTStep); 	  
	    }
	  }


	  public CANTNet getNewNet(String name,int cols, int rows,int topology){
	    iris2Net net = new iris2Net (name,cols,rows,topology);
	    return (net);
	  } 

		protected void createNeurons() {
			if (topology == 1) {
		        totalNeurons = 0;
		        neurons = new CANTNeuron[cols*rows];
		        for(int i=0;i< cols*rows;i++)
		          {
		          neurons[i] = new CANTNeuron(totalNeurons++,this);
		          //neurons[i] = new CANTNeuronSpontaneousFatigue(totalNeurons++,this);
		          neurons[i].setCompensatoryBase(10.0);
		          }
			}
			else if (topology == 2) {
				System.out.println(" creating fatigue neurons ");
				totalNeurons = 0;
				neurons = new CANTNeuronSpontaneousFatigue[cols * rows];
				for (int i = 0; i < cols * rows; i++) {
					neurons[i] = new CANTNeuronSpontaneousFatigue(totalNeurons++,this);
					neurons[i].setCompensatoryBase(10.0);
				}
				setInitialFatigue();
			}
			else if (topology == 3) {
				System.out.println(" creating fatigue neurons ");
				totalNeurons = 0;
				neurons = new CANTNeuronSpontaneousFatigue[cols * rows];
				for (int i = 0; i < cols * rows; i++) {
					neurons[i] = new CANTNeuronSpontaneousFatigue(totalNeurons++,this);
					neurons[i].setCompensatoryBase(10.0);
				}
				setInitialFatigue();
			}
			else System.out.println("error in iris2Net.createNuerons ");
		}
	  
	public void connectBaseToSomNet(iris2Net somNet) {
		for (int fromNeuron = 0; fromNeuron < getSize(); fromNeuron++) {
			int externalSynapses;
			externalSynapses = 20;
			for (int synapse = 0; synapse < externalSynapses; synapse++) {
				int toNeuron = CANT23.random.nextInt(somNet.getSize());
				neurons[fromNeuron].addConnection(somNet.neurons[toNeuron],
						0.001);
			}
		}
	}

	public void connectSomToOutputNet(iris2Net outputNet) {
		for (int fromNeuron = 0; fromNeuron < getSize(); fromNeuron++) {
			int externalSynapses;
			externalSynapses = 10;
			for (int synapse = 0; synapse < externalSynapses; synapse++) {
				int toNeuron = CANT23.random.nextInt(outputNet.getSize());
				neurons[fromNeuron].addConnection(outputNet.neurons[toNeuron],
						0.001);
			}
		}
	}
	public void connectOutputToSomNet(iris2Net somNet) {
		for (int fromNeuron = 0; fromNeuron < getSize(); fromNeuron++) {
			int externalSynapses;
			externalSynapses = 10;
			for (int synapse = 0; synapse < externalSynapses; synapse++) {
				int toNeuron = CANT23.random.nextInt(somNet.getSize());
				neurons[fromNeuron].addConnection(somNet.neurons[toNeuron],
						0.001);
			}
		}
	}
	
	  protected void setConnections() {
	    for(int i=0;i< cols*rows;i++)
	      {
	      if (neurons[i].isInhibitory())
	        setConnectionsRandomly(i,20,0.01);
	      else
	        setConnectionsRandomly(i,20,0.01);
	      }
	  }

	  //Fatigue should be relatively random to start.
	  public void setInitialFatigue() {
	    for(int i=0;i< cols*rows;i++) {
	      float newFatigue = CANT23.random.nextFloat();
	      newFatigue *= getActivationThreshold()*2;
	      newFatigue -= getActivationThreshold();
	      neurons[i].setFatigue(newFatigue);
	    }
	  }

	  //set fatigue between threshold and bottomVal
	  public void setInitialFatigue(double bottomVal) {
	    double range = getActivationThreshold() - bottomVal;
	    for(int i=0;i< cols*rows;i++) {
	      float newFatigue = CANT23.random.nextFloat();
	      newFatigue *= range;
	      newFatigue += bottomVal;
	      neurons[i].setFatigue(newFatigue);
	    }
	  }

	  private void setInputTopology() {
	      //setConnections(); no internal connections
	  }
	  
	private void setSOMTopology() {
		for (int fromNeuron = 0; fromNeuron < getSize(); fromNeuron++) {
			int internalSynapses;
			neurons[fromNeuron].setInhibitory(false);
			internalSynapses = 10;
			for (int synapses = 0; synapses < internalSynapses; synapses++) {
				int toNeuron = CANT23.random.nextInt(getSize());
				addConnection(fromNeuron, toNeuron, 0.02);
			}
		}
	}
	
	  
	private void setOutputTopology() {
		for (int fromNeuron = 0; fromNeuron < getSize(); fromNeuron++) {
			int internalSynapses;
			neurons[fromNeuron].setInhibitory(false);
			internalSynapses = 10;
			for (int synapses = 0; synapses < internalSynapses; synapses++) {
				int toNeuron = CANT23.random.nextInt(getSize());
				addConnection(fromNeuron, toNeuron, 0.02);
			}
		}
	}

	public void initializeNeurons() {
		// set up topologies.
		createNeurons();

		if (topology == 1) {
			// System.out.println("iris2 input topology ");
			setInputTopology();
		} else if (topology == 2) {
			// System.out.println("iris2 som topology ");
			setSOMTopology();
		} else if (topology == 3) {
			// System.out.println("iris2 som topology ");
			setOutputTopology();
		} else
			System.out.println("bad toppology specified " + topology);
	}

	  private double getTotalWeights(CANTNeuron neuron) {
	    double toWeight = 0.0;
	    for (int synapse = 0; synapse < neuron.getCurrentSynapses(); synapse ++) {
	      toWeight += neuron.synapses[synapse].getWeight();
	    }
	    return (toWeight);
	  }


	    
	    
	    private void compense(int fromOffset, int synapse) {
			CANTNeuronSpontaneousFatigue toNeuron = (CANTNeuronSpontaneousFatigue) 
					neurons[fromOffset].synapses[synapse].getTo();
	        double connectionStrength = neurons[fromOffset].synapses[synapse].getWeight();

	        neurons[fromOffset].setInhibitory(false);

	        
			if (toNeuron.getFired())
			  {
	          double modification = neurons[fromOffset].getIncreaseBase(connectionStrength);
	          modification *= getLearningRate();
	          connectionStrength = connectionStrength+modification;
	          neurons[fromOffset].synapses[synapse].setWeight(connectionStrength);
	//System.out.println(fromOffset + " hebb compense + " + connectionStrength + " " + modification); 
			  }
			else 
			  {
		          double modification = neurons[fromOffset].getDecreaseBase(connectionStrength);
		          modification *= getLearningRate();
		          connectionStrength = connectionStrength-modification;
		          neurons[fromOffset].synapses[synapse].setWeight(connectionStrength);
		//System.out.println(fromOffset + " hebb compense - " + connectionStrength + " " + modification); 
				  }
		}
	    

	  public void learn() {
		int learningOn = getLearningOn();
	    if (learningOn == 0) return;
	    else if (learningOn == 1)
	    {
		    int totalNeurons = size();
		    for (int neuronIndex = 0; neuronIndex < totalNeurons; neuronIndex++) 
		      {
		      String netName = getName();
		      if (netName.equals("BaseNet"))  		
		        neurons[neuronIndex].learn4();
		      else if ((netName.equals("SomNet")) || (netName.equals("OutputNet")))  
	//if ((neuronIndex == 0) && neurons[0].getFired())	    	  
	//System.out.println(" neuron 0 fired " + iris2CANT.CANTStep); 
			    neurons[neuronIndex].learnPostCompense();
		      }
	    }
	    else 
	    	System.out.println(" bad learning on in iris2Net learn " + learningOn); 
	 }
	  
	  private int somOn = -1;

		private void printSOMOn() {
			iris2Net somNet = (iris2Net) CANT23.experiment.getNet("SomNet");

			//for (int CA = 0; CA < 10; CA++) {
				for (int CA = 0; CA < 5; CA++) {
				int neuronsFiring = 0;
				for (int i = 0; i < 100; i++) {
					if (somNet.neurons[i + (CA * 100)].getFired())
						neuronsFiring++;
				}
				if (neuronsFiring > 50) {
					if (somOn == -1) {
						somOn = CA;
						System.out.println(CA + " CA on " + CANT23.CANTStep);
					} else if (CA != somOn) {
						System.out.println(CA + " CA and CA  " + somOn + " on "
								+ CANT23.CANTStep);
					}
				} else if ((CA == somOn) && (neuronsFiring == 0)) {
					System.out.println(CA + " CA off " + CANT23.CANTStep);
					somOn = -1;
				}
			}
		}

	  private void printSOMPlace(int CA){
		//Look through all the input neurons and see what the weights are to this CA.
	    iris2Net inputNet = (iris2Net) CANT23.experiment.getNet("BaseNet");
		double xWeights[];
		int xSynapses[];
		double yWeights[];
		int ySynapses[];
		xWeights = new double[10];
		xSynapses = new int[10];
		yWeights = new double[10];
		ySynapses = new int[10];
		
		 System.out.println("To CA " + CA);
				 
		for (int i = 0; i < 10; i++){
			xWeights[i]=0.0;
			xSynapses[i] = 0;
			yWeights[i]=0.0;
			ySynapses[i] = 0;
		}
		
		//Get the x values by looking at all the synapses
		for (int neuronOffset =0; neuronOffset < 100; neuronOffset++) {
			for (int syn=0; syn<inputNet.neurons[neuronOffset].getCurrentSynapses();syn++) {
				int toNeuronId = inputNet.neurons[neuronOffset].synapses[syn].toNeuron.getId();
				if ((toNeuronId/100) == CA) {
				  int xBin = neuronOffset/10;
				  xWeights[xBin] += inputNet.neurons[neuronOffset].synapses[syn].getWeight();
				  xSynapses[xBin]++;
				}
			}
		}
		
		//Get the y values by looking at all the synapses
		for (int neuronOffset =100; neuronOffset < 200; neuronOffset++) {
			for (int syn=0; syn<inputNet.neurons[neuronOffset].getCurrentSynapses();syn++) {
				int toNeuronId = inputNet.neurons[neuronOffset].synapses[syn].toNeuron.getId();
				if ((toNeuronId/100) == CA) {
				  int yBin = (neuronOffset-100)/10;
				  yWeights[yBin] += inputNet.neurons[neuronOffset].synapses[syn].getWeight();
				  ySynapses[yBin]++;
				}
			}
		}

		//print out the values to this CA.
		for (int i = 0; i < 10; i++){
	        System.out.println(i + " " + xWeights[i] +  " " + yWeights[i]);
		}
	  }
	  
	  public void printSomLocales() {
		  System.out.println("Soms " + CANT23.CANTStep);
		  for (int CA = 0; CA < 5; CA++) {
				//Look through all the input neurons and see what the weights are to this CA.
			    iris2Net inputNet = (iris2Net) CANT23.experiment.getNet("BaseNet");
				double xWeights[];
				int xSynapses[];
				double yWeights[];
				int ySynapses[];
				xWeights = new double[10];
				xSynapses = new int[10];
				yWeights = new double[10];
				ySynapses = new int[10];
							 
				for (int i = 0; i < 10; i++){
					xWeights[i]=0.0;
					xSynapses[i] = 0;
					yWeights[i]=0.0;
					ySynapses[i] = 0;
				}
				
				//Get the x values by looking at all the synapses
				for (int neuronOffset =0; neuronOffset < 100; neuronOffset++) {
					for (int syn=0; syn<inputNet.neurons[neuronOffset].getCurrentSynapses();syn++) {
						int toNeuronId = inputNet.neurons[neuronOffset].synapses[syn].toNeuron.getId();
						if ((toNeuronId/100) == CA) {
						  int xBin = neuronOffset/10;
						  xWeights[xBin] += inputNet.neurons[neuronOffset].synapses[syn].getWeight();
						  xSynapses[xBin]++;
						}
					}
				}
				
				//Get the y values by looking at all the synapses
				for (int neuronOffset =100; neuronOffset < 200; neuronOffset++) {
					for (int syn=0; syn<inputNet.neurons[neuronOffset].getCurrentSynapses();syn++) {
						int toNeuronId = inputNet.neurons[neuronOffset].synapses[syn].toNeuron.getId();
						if ((toNeuronId/100) == CA) {
						  int yBin = (neuronOffset-100)/10;
						  yWeights[yBin] += inputNet.neurons[neuronOffset].synapses[syn].getWeight();
						  ySynapses[yBin]++;
						}
					}
				}

			int bestX = 0;
			double bestXVal = xWeights[0];	
			for (int i = 1; i < 10; i++){
				if (bestXVal < xWeights[i]) {
					bestX = i;
					bestXVal = xWeights[i];
				}			
			}
			int bestY = 0;
			double bestYVal = yWeights[0];	
			for (int i = 1; i < 10; i++){
				if (bestYVal < yWeights[i]) {
					bestY = i;
					bestYVal = yWeights[i];
				}			
			}
			//print out the values to this CA.
		    System.out.println(CA + " " + bestX + " " +bestY);
		  }
	  }
	  
	private void printWeights(int category, iris2Net fromNet) {
		int categorySize = 50; //parameter 
		double totalWeight = 0.0;
		int synapses = 0;
		for (int neuron = 0; neuron < fromNet.getSize(); neuron++) {
			for (int synapse = 0; synapse < fromNet.neurons[neuron]
					.getCurrentSynapses(); synapse++) {
				if (fromNet.neurons[neuron].synapses[synapse].toNeuron.parentNet
						.getName().compareTo("OutputNet") == 0) {
					int toNeuronID = fromNet.neurons[neuron].synapses[synapse].toNeuron
							.getId();
					if ((toNeuronID >= ((category - 1) * categorySize))
							&& (toNeuronID < (category * categorySize))) {
						totalWeight += fromNet.neurons[neuron].synapses[synapse]
								.getWeight();
						synapses++;
					}
				}
			}
		}
		double avgWeight = totalWeight / synapses;
		System.out.println("kludge " + category + " " + synapses + " "
				+ avgWeight);
	}

	private void printWeights(int category) {
		iris2Net outputNet = (iris2Net) CANT23.experiment.getNet("OutputNet");
		iris2Net somNet = (iris2Net) CANT23.experiment.getNet("SomNet");
		printWeights(category, somNet);
		printWeights(category, outputNet);
	}
	  public void kludge () {
	    System.out.println("kludge" + iris2CANT.kludge );
	    iris2Net net = (iris2Net) CANT23.experiment.getNet("SomNet");

	    
	    if (iris2CANT.kludge == 0) {
	      net = (iris2Net) CANT23.experiment.getNet("BaseNet");
	      for (int i= 0; i < 10; i++) 
	        {
	       double totalWeights = getTotalWeights(net.neurons[i]);
	        System.out.println(i + " " + totalWeights + " " +  net.neurons[i].getFatigue()); 
	        }
	    }
	    else if (iris2CANT.kludge == 1) {
	    	iris2CANT.experiment.debugPrintTrainTestNets();
	      }
	    else if (iris2CANT.kludge == 2) {
		    printWeights(1);
		    printWeights(2);
		    printWeights(3);
	    }
	    else if (iris2CANT.kludge == 3) {
	        for (int i= 0; i < 10; i++) 
	          {
	          System.out.println(i + " " +  net.neurons[i].getFatigue()); 
	          }
	      }
	    else {
	        for (int i= 0; i < 10; i++) 
	        {
	        System.out.println(i + " act " +  net.neurons[i].getActivation()); 
	        }
	    }
	    /*
	           double avgWeights;
	      double totalWeights = getTotalWeights(net.neurons[i]);
	      avgWeights = getTotalWeights(net.neurons[i],"OutputNet");
	      System.out.println(i + " " + avgWeights + " " + totalWeights); 
	      //System.out.println(i + " " + this.neurons[i].getActivation() + 
	      //                      " " + this.neurons[i].getFatigue());
	      */
	  }
	  
	  public void measure(int currentStep) {
	    System.out.println("measure " + neurons[0].getActivation() + " " + 
	      neurons[0].getFired() + " " + 
		  currentStep);
	  }
	}